<%-- input_date_combo tag --%>
<%@ tag pageEncoding="UTF-8" body-content="empty"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://www.jasminesoft.co.jp/jfc" prefix="jfc" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tags" %>
<fmt:setBundle basename="jfcapp"/>

<%@ attribute name="value" required="true" type="java.lang.Object" %> <%-- ${TemplateModel_p.FDateCombo} --%>
<%@ attribute name="name" required="true" %> <%-- TemplateModel_p$002ff_date_combo --%>
<%@ attribute name="isReadonly" type="java.lang.Boolean" %>
<%@ attribute name="year_textfield" type="java.lang.Boolean" %>
<%@ attribute name="year_begin" %> <%-- 1990 --%>
<%@ attribute name="year_range" %> <%-- 10 --%>
<%@ attribute name="type" required="true" %> <%-- YMDHMS or YMDHM or YMDH or YMD or YM or Y --%>
<%@ attribute name="subformat" %> <%-- common.js formatDateObject function --%>
<%@ attribute name="rangetype" %> <%-- normal or begin or end or onerange --%>
<%@ attribute name="onerangeEndName" %>
<%@ attribute name="onerangeEndValue" type="java.lang.Object" %>
<%@ attribute name="nendoBeginMonth" type="java.lang.Integer" %> <%-- 1...12 --%>
<%@ attribute name="onchange" %>
<%@ attribute name="onkeydown" %>
<%@ attribute name="isOutputFieldClass" type="java.lang.Boolean" %>
<%@ attribute name="fieldClassSuffix" %>
<%@ attribute name="selectinput_config" %>
<%@ attribute name="size" %> <%-- use only selectinput_config is input --%>
<%@ attribute name="maxlength" %> <%-- use only selectinput_config is input --%>
<%@ attribute name="valuetype" %> <%-- date or dateTime, default is date --%>
<%@ attribute name="isCalendarinput" type="java.lang.Boolean" %> <%-- use only selectinput_config is input --%>
<%@ attribute name="calendarinputDateFormat" %>
<%@ attribute name="calendarinputButtonType" %>
<%@ attribute name="calendarinputButtonTypeImageSrc" %>
<%@ attribute name="dateformat" %>
<%@ attribute name="isMobile" type="java.lang.Boolean" %>
<%@ attribute name="isFeaturePhone" type="java.lang.Boolean" %>
<%@ attribute name="isRequired" type="java.lang.Boolean" %>
<%@ attribute name="tabIndex" %>
<%@ attribute name="timeSelectInput" %>

<c:choose>
<c:when test="${isReadonly}">
  <span id="content_${name}"><c:out value="${value.content}"/></span>
  <tags:show_text name="${name}" content="${value.content}" subformat="${subformat}"/>
</c:when>
<c:when test="${fn:startsWith(selectinput_config,'input')}">

<tags:input_date_combo_input
    value="${value}"
    name="${name}"
    isReadonly="${isReadonly}"
    year_textfield="${year_textfield}"
    year_begin="${year_begin}"
    year_range="${year_range}"
    type="${type}"
    subformat="${subformat}"
    rangetype="${rangetype}"
    onerangeEndName="${onerangeEndName}"
    onerangeEndValue="${onerangeEndValue}"
    nendoBeginMonth="${nendoBeginMonth}"
    onchange="${onchange}"
    onkeydown="${onkeydown}"
    isOutputFieldClass="${isOutputFieldClass}"
    fieldClassSuffix="${fieldClassSuffix}"
    selectinput_config="${selectinput_config}"
    size="${size}"
    maxlength="${maxlength}"
    valuetype="${valuetype}"
    isCalendarinput="${isCalendarinput}"
    calendarinputDateFormat="${calendarinputDateFormat}"
    calendarinputButtonType="${calendarinputButtonType}"
    calendarinputButtonTypeImageSrc="${calendarinputButtonTypeImageSrc}"
    dateformat="${dateformat}" 
    isRequired="${isRequired}"
    tabIndex="${tabIndex}"
/>

<c:if test="${fn:length(subformat) > 0}">
  <tags:src_input_subformat
      value="${value}"
      name="${name}"
      subformat="${subformat}"/>
</c:if>
</c:when>
<c:otherwise>
<%-- not readonly --%>

<%-- __class variable --%>
<c:set var="__class" value=""/>
<c:choose>
<c:when test="${isOutputFieldClass}">
  <c:choose>
  <c:when test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield${fieldClassSuffix}"/>
  </c:when>
  <c:otherwise>
    <c:set var="__class" value="field${fieldClassSuffix}"/>
  </c:otherwise>
  </c:choose>
</c:when>
<c:otherwise>
  <c:if test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield_nowidth"/>
  </c:if>
</c:otherwise>
</c:choose>

<c:set var="_onchange">expandDate_${name}(this.form)</c:set>

<c:if test="${fn:length(subformat) > 0}">
  <c:set var="_onchange">${_onchange};changeSubformatDisplay(this,'${name}__subformat','${subformat}')</c:set>
</c:if>

<c:set var="onchange">${_onchange};${onchange}</c:set>

<%-- nendoBeginMonth --%>
<c:if test="${nendoBeginMonth != null}">
  <c:choose>
  <c:when test="${nendoBeginMonth > 1}">
    <c:set var="nendoEndMonth">${nendoBeginMonth-1}</c:set>
  </c:when>
  <c:otherwise>
    <c:set var="nendoEndMonth">12</c:set>
  </c:otherwise>
  </c:choose>
</c:if>

<%-- year --%>
<c:choose>
<c:when test="${year_textfield || fn:startsWith(selectinput_config,'text')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" name="${name}_year" onchange="${onchange}" value="" size="6" maxlength="4"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<c:if test="${isFeaturePhone == true}">
<c:set var="__selected_year" value="${fn:substringBefore(value.content, '-')}"/>
<c:set var="__selected_month" value="${fn:substringBefore(fn:substringAfter(value.content, '-'), '-')}"/>
<c:if test="${fn:startsWith(__selected_month, '0')}">
<c:set var="__selected_month" value="${fn:substringAfter(__selected_month, '0')}"/>
</c:if>
<c:set var="__selected_day" value="${fn:substringAfter(fn:substringAfter(value.content, '-'), '-')}"/>
<c:choose>
<c:when test="${fn:startsWith(__selected_day, '0')}">
<c:set var="__selected_day" value="${fn:substring(__selected_day, 1, 2)}"/>
</c:when>
<c:otherwise>
<c:set var="__selected_day" value="${fn:substring(__selected_day, 0, 2)}"/>
</c:otherwise>
</c:choose>
</c:if>

<c:set var="_dojoType" value="data-dojo-type=\"wagby/Select\" "/>
<c:set var="_style" value="style=\"width: 4em;\" "/>
<c:if test="${isMobile}">
<c:set var="_dojoType" value=""/>
<c:set var="_style" value=""/>
</c:if>
<select ${_dojoType}id="${name}_year" name="${name}_year" ${_style}onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=""></option>
<c:forEach var="__year" begin="${year_begin}" end="${year_begin + year_range}">
<option<c:if test="${isFeaturePhone && (__year == __selected_year)}"> selected="selected"</c:if> value="${__year}">
<c:out value="${__year}"/>
</option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<c:choose>
<c:when test="${nendoBeginMonth != null}">
<fmt:message key="__jfc_common.yearnendo"/>
</c:when>
<c:otherwise>
<fmt:message key="__jfc_common.year"/>
</c:otherwise>
</c:choose>
<%-- month --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM' || type == 'YMDH' || type == 'YMD' || type == 'YM'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ym')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" name="${name}_month" onchange="checkMonthValue_${name}(this.textbox.form);${onchange}" size="4" maxlength="2"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select ${_dojoType}id="${name}_month" name="${name}_month" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=""></option>
<c:choose>
<c:when test="${nendoBeginMonth != null}">
<c:forEach var="__month" begin="${nendoBeginMonth}" end="12">
<option<c:if test="${isFeaturePhone && (__month == __selected_month)}"> selected="selected"</c:if> value="${__month}"><c:out value="${__month}"/></option>
</c:forEach>
<c:if test="${nendoBeginMonth > 1}">
<c:forEach var="__month" begin="1" end="${nendoEndMonth}">
<option<c:if test="${isFeaturePhone && (__month == __selected_month)}"> selected="selected"</c:if> value="${__month}"><c:out value="${__month}"/></option>
</c:forEach>
</c:if>
</c:when>
<c:otherwise>
<c:forEach var="__month" begin="1" end="12">
<option<c:if test="${isFeaturePhone && (__month == __selected_month)}"> selected="selected"</c:if> value="${__month}"><c:out value="${__month}"/></option>
</c:forEach>
</c:otherwise>
</c:choose>
</select>
</c:otherwise>
</c:choose>
<fmt:message key="__jfc_common.month"/>
</c:if>
<%-- day --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM' || type == 'YMDH' || type == 'YMD'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymd')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" name="${name}_day" onchange="checkDayValue_${name}(form);${onchange}" size="4" maxlength="2"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select ${_dojoType}id="${name}_day" name="${name}_day" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=""></option>
<c:forEach var="__day" begin="1" end="31">
<option<c:if test="${isFeaturePhone && (__day == __selected_day)}"> selected="selected"</c:if> value="${__day}"><c:out value="${__day}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<fmt:message key="__jfc_common.day"/>
</c:if>
<%-- hour --%>
<span style="display: inline-block;">
<c:if test="${type == 'YMDHMS' || type == 'YMDHM' || type == 'YMDH'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymdh')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" name="${name}_hour" onchange="checkHourValue_${name}(form);${onchange}" size="4" maxlength="2"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select ${_dojoType}id="${name}_hour" name="${name}_hour" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=""></option>
<c:forEach var="__hour" begin="0" end="23">
<option value="${__hour}"><c:out value="${__hour}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<fmt:message key="__jfc_common.hour"/>
</c:if>
<%-- minute --%>
<c:if test="${type == 'YMDHMS' || type == 'YMDHM'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymdhm')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" name="${name}_minute" onchange="checkMinuteValue_${name}(form);${onchange}" size="4" maxlength="2"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select ${_dojoType}id="${name}_minute" name="${name}_minute" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=""></option>
<c:forEach var="__minute" begin="0" end="59">
<option value="${__minute}"><c:out value="${__minute}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<fmt:message key="__jfc_common.minute"/>
</c:if>
<%-- second --%>
<c:if test="${type == 'YMDHMS'}">
<c:choose>
<c:when test="${fn:startsWith(selectinput_config,'text_ymdhms')}">
<input data-dojo-type="dijit/form/ValidationTextBox" type="text" name="${name}_second" onchange="checkSecondValue_${name}(form);${onchange}" size="4" maxlength="2"
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- input --%>
</c:when>
<c:otherwise>
<select ${_dojoType}id="${name}_second" name="${name}_second" onchange="${onchange}"
<c:if test="${fn:length(onkeydown) > 0}"> onKeyDown="${onkeydown}"</c:if>
<c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
> <%-- select --%>
<option value=""></option>
<c:forEach var="__second" begin="0" end="59">
<option value="${__second}"><c:out value="${__second}"/></option>
</c:forEach>
</select>
</c:otherwise>
</c:choose>
<fmt:message key="__jfc_common.second"/>
</c:if>
</span>
<c:if test="${!isFeaturePhone}">
<tags:src_input_date_combo_notreadonly_javascript
    name="${name}"
    type="${type}" />

<tags:src_input_date_combo_javascript
    value="${value}"
    name="${name}"
    year_textfield="${year_textfield}"
    year_begin="${year_begin}"
    year_range="${year_range}"
    type="${type}"
    subformat="${subformat}"
    rangetype="${rangetype}"
    onerangeEndName="${onerangeEndName}"
    onerangeEndValue="${onerangeEndValue}"
    nendoBeginMonth="${nendoBeginMonth}"
    selectinput_config="${selectinput_config}"
    valuetype="${valuetype}" />
</c:if>

<c:if test="${fn:length(subformat) > 0}">
  <tags:src_input_subformat
      value="${value}"
      name="${name}"
      subformat="${subformat}"/>
</c:if>
</c:otherwise>
</c:choose>
